【PAT】Acute Stroke 求联通块三维版本,使用BFS算法+常数优化

26 篇文章 0 订阅
8 篇文章 0 订阅

题目链接 https://pintia.cn/problem-sets/994805342720868352/problems/994805375457411072

题目描述

One important factor to identify acute stroke (急性脑卒中) is the volume of the stroke core.  Given the results of image analysis in which the core regions are identified in each MRI slice, your job is to calculate the volume of the stroke core.

 

输入描述:

Each input file contains one test case.  For each case, the first line contains 4 positive integers: M, N, L and T, where M and N are the sizes of each slice (i.e. pixels of a slice are in an M by N matrix, and the maximum resolution is 1286 by 128); L (<=60) is the number of slices of a brain; and T is the integer threshold (i.e. if the volume of a connected core is less than T, then that core must not be counted).
Then L slices are given.  Each slice is represented by an M by N matrix of 0's and 1's, where 1 represents a pixel of stroke, and 0 means normal.  Since the thickness of a slice is a constant, we only have to count the number of 1's to obtain the volume.  However, there might be several separated core regions in a brain, and only those with their volumes no less than T are counted. Two pixels are "connected" and hence belong to the same region if they share a common side, as shown by Figure 1 where all the 6 red pixels are connected to the blue one.


Figure 1


 

输出描述:

For each case, output in a line the total volume of the stroke core.

 

输入例子:

3 4 5 2
1 1 1 1
1 1 1 1
1 1 1 1
0 0 1 1
0 0 1 1
0 0 1 1
1 0 1 1
0 1 0 0
0 0 0 0
1 0 1 1
0 0 0 0
0 0 0 0
0 0 0 1
0 0 0 1
1 0 0 0

 

输出例子:

26

题意就是求联通块的三维版本,然后记录联通块中有多少个1,如果该联通块1的数量小于t就不记录。然后不能使用DFS,因为该数据量会爆栈,所以用BFS,这点很多博主都说过了。开此贴记录的原因是因为此帖如果开数组的顺序不一样(当然调用顺序也改正确的情况下)在PTA官网是过不去的,在牛客上可以过,因为牛客的数据水一点,这点好像没看到其他博主提到过,这可能跟多维数组的内存连续分配缓存方式有关吧。如果有知道的比较详细的欢迎留言

#include<iostream>
#include<cstdio>
#include<queue>
using namespace std;
//这里开数组的顺序是70 1300 200的原题目顺序就会TLE(当然调用顺序也改正确的情况下),可能跟多维数组的内存连续分配缓存方式有关,具体我也不清楚,望指教
int image[1300][200][70],vis[1300][200][70]={0},dir[6][3]={{1,0,0},{-1,0,0},{0,1,0},{0,-1,0},{0,0,1},{0,0,-1}}; 
int m,n,l,t,ans=0;
struct point
{
	int x,y,z;
	point(int x,int y,int z)
	{
		this->x=x;
		this->y=y;
		this->z=z;
	}
};
int bfs(int x,int y,int z)
{
	int num=1;
	vis[x][y][z]=1;
	queue<point> q;
	q.push(point(x,y,z));
	while(!q.empty())
	{
		point p=q.front();
		q.pop();
		for(int i=0;i<6;i++)//每次前后左右上下遍历 
		{
			point next_p=point(p.x+dir[i][0],p.y+dir[i][1],p.z+dir[i][2]);
			if(next_p.x<0||next_p.x>=m||next_p.y<0||next_p.y>=n||next_p.z<0||next_p.z>=l||vis[next_p.x][next_p.y][next_p.z]||image[next_p.x][next_p.y][next_p.z]==0)
				continue;//边界情况跳出 
			vis[next_p.x][next_p.y][next_p.z]=1;//标记为已访问并且联通块数量自增 
			num++;
			q.push(next_p);
		}
	}
	return num;
}
int main()
{
	scanf("%d %d %d %d",&m,&n,&l,&t);
	for(int i=0;i<l;i++)//输入三维图像矩阵 
		for(int j=0;j<m;j++)
			for(int k=0;k<n;k++)
				scanf("%d",&image[j][k][i]);
	for(int i=0;i<l;i++)
		for(int j=0;j<m;j++)
			for(int k=0;k<n;k++)
				if(!vis[j][k][i]&&image[j][k][i])//如果没被访问过并且该点为1的话开始遍历联通块 
				{
					int num=bfs(j,k,i);
					if(num>=t)//联通块数量大于t记录 
						ans+=num;
				}
	printf("%d",ans);
	return 0;
}

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值